-- Function to toggle invulnerability
COM_AddCommand("invulnerability", function(player, arg)
    if player == server or player == admin then
        if player.powers[pw_invulnerability] == 0 then
            player.powers[pw_invulnerability] = INT32_MAX
            CONS_Printf(player, "Invulnerability enabled")
        else
            player.powers[pw_invulnerability] = 0
            CONS_Printf(player, "Invulnerability disabled")
        end
    end
end)

-- Function to toggle supersneakers
COM_AddCommand("supersneakers", function(player, arg)
    if player == server or player == admin then
        if player.powers[pw_sneakers] == 0 then
            player.powers[pw_sneakers] = INT32_MAX
            CONS_Printf(player, "Super sneakers enabled")
        else
            player.powers[pw_sneakers] = 0
            CONS_Printf(player, "Super sneakers disabled")
        end
    end
end)

-- Function to toggle flashing
COM_AddCommand("flashing", function(player, arg)
    if player == server or player == admin then
        if player.powers[pw_flashing] == 0 then
            player.powers[pw_flashing] = INT32_MAX
            CONS_Printf(player, "Flashing enabled")
        else
            player.powers[pw_flashing] = 0
            CONS_Printf(player, "Flashing disabled")
        end
    end
end)

-- Function to give infinite rings or reset to 0
COM_AddCommand("giveinfrings", function(player, arg)
    if player == server or player == admin then
        if player.rings ~= 9999 then
            player.rings = 9999
            CONS_Printf(player, "Gave infinite rings")
        else
            player.rings = 0
            CONS_Printf(player, "Successfully set rings back to 0")
        end
    end
end)

-- Function to give different types of shields
COM_AddCommand("shield", function(player, arg)
    if player == server or player == admin then
        if arg == "fire" then
            player.powers[pw_shield] = SH_FLAMEAURA
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave fire shield.")
        elseif arg == "water" then
            player.powers[pw_shield] = SH_BUBBLEWRAP
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave water shield.")
        elseif arg == "lightning" then
            player.powers[pw_shield] = SH_THUNDERCOIN
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave lightning shield.")
        elseif arg == "force" then
            player.powers[pw_shield] = SH_FORCE
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave force shield.")
        elseif arg == "elemental" then
            player.powers[pw_shield] = SH_ELEMENTAL
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave elemental shield.")
        elseif arg == "armageddon" then
            player.powers[pw_shield] = SH_ARMAGEDDON
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave armageddon shield.")
        elseif arg == "attract" then
            player.powers[pw_shield] = SH_ATTRACT
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave attract shield.")
        elseif arg == "pity" then
            player.powers[pw_shield] = SH_PITY
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave pity shield.")
        elseif arg == "whirlwind" then
            player.powers[pw_shield] = SH_WHIRLWIND
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave whirlwind shield.")
        elseif arg == "pink" then
            player.powers[pw_shield] = SH_PINK
            P_SpawnShieldOrb(player)
            CONS_Printf(player, "Successfully gave pink shield.")
        elseif arg == "none" then
            player.powers[pw_shield] = SH_NONE
            CONS_Printf(player, "Successfully removed shield.")
        else
            CONS_Printf(player, "Did you even insert a shield name?")
        end
    end
end)

-- Function to print a message
COM_AddCommand("print", function(player, arg)
    if player == server or player == admin then
        if arg then
            CONS_Printf(player, arg)
        else
            CONS_Printf(player, "No message provided.")
        end
    end
end)

--- Function to give rings
COM_AddCommand("giverings", function(player, arg)
    if player == server or player == admin then
        local ringAmount = tonumber(arg)
        if ringAmount ~= nil then  -- Check if ringAmount is a number
            player.rings = ringAmount  -- Set the rings directly
            CONS_Printf(player, "Rings set to " .. ringAmount .. ".")
        else
            CONS_Printf(player, "Invalid ring amount, please provide a valid number.")
        end
    else
        CONS_Printf(player, "You don't have permission to use this command.")
    end
end)
-- Function to set player skin
COM_AddCommand("setskin", function(player, arg)
    if player == server or player == admin then
        if arg then
            if skins[arg] then
                if player.mo.skin ~= arg then
                    player.mo.skin = arg
                    R_SetPlayerSkin(player, arg)
                    CONS_Printf(player, "Skin set to " .. arg .. ".")
                else
                    CONS_Printf(player, "Skin is already set to " .. arg .. ".")
                end
            else
                CONS_Printf(player, "The skin '" .. arg .. "' is not valid.")
            end
        else
            CONS_Printf(player, "Please specify a skin.")
        end
    else
        CONS_Printf(player, "You do not have permission to use this command.")
    end
end)

-- Function to set player speed
COM_AddCommand("speed", function(player, arg)
    if player == server or player == admin then
        if arg then
            local speed = tonumber(arg)
            if speed then
                if speed >= 5000 then
                    CONS_Printf(player, "Speed too high, resetting to default and dying.")
                    player.rings = 0
                    P_KillMobj(player.mo, nil, nil)
                else
                    player.normalspeed = speed * FRACUNIT
                    CONS_Printf(player, "Speed set to " .. speed .. ".")
                end
            else
                CONS_Printf(player, "Invalid number.")
            end
        else
            CONS_Printf(player, "Specify a speed value.")
        end
    else
        CONS_Printf(player, "You don't have permission to use this command.")
    end
end)

-- Function to spawn emeralds
COM_AddCommand("emeralds", function(player, arg)
    if player == server or player == admin then
        local emeraldCount = tonumber(arg)
        if emeraldCount and emeraldCount >= 1 and emeraldCount <= 7 then
            local emeraldTypes = {
                MT_EMERALD1,
                MT_EMERALD2,
                MT_EMERALD3,
                MT_EMERALD4,
                MT_EMERALD5,
                MT_EMERALD6,
                MT_EMERALD7
            }

            local x = player.mo.x
            local y = player.mo.y
            local z = player.mo.z
            
            for i = 1, emeraldCount do
                P_SpawnMobj(x + i * FRACUNIT, y + i * FRACUNIT, z, emeraldTypes[i])
            end
            
            CONS_Printf(player, "Gave " .. emeraldCount .. " emerald(s).")
        else
            CONS_Printf(player, "Invalid input of emeralds, please try again.")
        end
    end
end)
